#include "game_container.h"
#include "utils.h"

using namespace std;

void run_container_test() {

	GameObject* obj1 = new GameObject(_T("object 1"));
	GameObject* obj2 = new GameObject(_T("object 2"));
	GameObject* obj3 = new GameObject(_T("object 1"));
	GameContainer gameCont((CEsmContainer*)CEsmContainer::Create(), "container");
	
	if (gameCont.contains(obj1) || gameCont.contains(obj2) || gameCont.contains(obj3)) {
		cout << "Failed contains test #1" << endl;
	} else {
		cout << "Passed contains test #1" << endl;
	}

	gameCont.add(obj1, 2);
	if (gameCont.contains(obj1)) {
		cout << "Passed add test #1" << endl;
	} else {
		cout << "Failed add test #1" << endl;
	}

	if (gameCont.contains(obj3)) {
		cout << "Passed add test #2" << endl;
	} else {
		cout << "Failed add test #2" << endl;
	}

	if (gameCont.contains(obj1) && gameCont.contains(obj3) && !gameCont.contains(obj2)) {
		cout << "Passed contains test #2" << endl;
	} else {
		cout << "Failed contains test #2" << endl;
	}
	
	if (gameCont.count(obj1) == 2) {
		cout << "Passed count test #1" << endl;
	} else {
		cout << "Failed count test #1" << endl;
	}

	if (gameCont.count(obj2) == 0) {
		cout << "Passed count test #2" << endl;
	} else {
		cout << "Failed count test #2" << endl;
	}

	if (gameCont.count(obj3) == 2) {
		cout << "Passed count test #3" << endl;
	} else {
		cout << "Failed count test #3" << endl;
	}

	cout << endl << "----------------------------------" << endl;
	cout << "Print Test --- verify manually" << endl;
	printRecord((CEsmRecord*)gameCont.toESMContainer());
	cout << endl << "----------------------------------" << endl;

	gameCont.remove(obj1, 1);
	if (gameCont.count(obj1) == 1 && gameCont.count(obj3) == 1) {
			cout << "Passed remove test #1" << endl;
	} else {
			cout << "Failed remove test #1" << endl;
	}

	gameCont.add(obj1, 1);
	if (gameCont.contains(obj1)) {
		cout << "Passed remove test #2a" << endl;
		gameCont.clear();
		if (gameCont.contains(obj3) || gameCont.contains(obj1)) {
			cout << "Failed remove test #2b" << endl;
		} else {
			cout << "Passed remove test #2b" << endl;
		}
	} else {
		cout << "Failed remove test #2a" << endl;
	}
}