#include "predicate_handler.h"
#include <iostream>
using namespace std;
using namespace xercesc;

MySAX2Handler::~MySAX2Handler() { }

void MySAX2Handler::startElement(const   XMLCh* const    uri,
								 const   XMLCh* const    localname,
								 const   XMLCh* const    qname,
								 const   Attributes&     attrs) 
{
	int subj = 0, pred = 1, obj = 2;
	char* name = XMLString::transcode(qname);
	char* pred_string, *subject, *object;
	int predicate;
	if (XMLString::equals(name, "tuple")) {
		pred_string = XMLString::transcode(attrs.getValue(pred));
		predicate = Room::getPredicate(pred_string);
		subject = XMLString::transcode(attrs.getValue(subj));
		object = XMLString::transcode(attrs.getValue(obj));
		
		if (predicate == IS_A) {
			igraph.addEdge(subject, object, predicate);
		} else if (predicate != UNKNOWN) {
			if (pgraph.hasEdge(subject, object)) {
				predicate |= pgraph.edgeWeight(subject, object);
			}
			pgraph.addEdge(subject, object, predicate);
		}
	}
	XMLString::release(&name);
}

void MySAX2Handler::fatalError(const SAXParseException& exception)
{
	char* message = XMLString::transcode(exception.getMessage());
	cout << "Fatal Error: " << message
		<< " at line: " << exception.getLineNumber()
		<< endl;

}
