#include "utils.h"

CEsmSubCellRef* addCREF(CEsmRecord* pRecord, TCHAR* pName, pos6data_t* pPos) {
	CEsmSubCellRef* cref = (CEsmSubCellRef*)pRecord->AllocateSubRecord(MWESM_SUBREC_CREF);

	// this is kind of annoying, not entirely sure why it's necessary
	// adding a new piece to the cell
	CEsmSubFRMR* frmr;
	CreatePointerL(frmr, CEsmSubFRMR);
	frmr->SetType(MWESM_SUBREC_FRMR);
	frmr->SetRecordSize(4);
	frmr->SetValue(4);
	cref->AddSubRec(frmr);

	CEsmSubName* pSubName;
	CreatePointerL(pSubName, CEsmSubName);
	pSubName->SetType(MWESM_SUBREC_NAME);
	pSubName->SetName(pName);
	cref->AddSubRec(pSubName);

	CEsmSubPos6* pos;
	CreatePointerL(pos, CEsmSubPos6);
	pos->SetType(MWESM_SUBREC_DATA);
	pos->CreateNew();
	pos6data_t* pPosData = pos->GetPosData();
	pPosData->PosX = pPos->PosX;
	pPosData->PosY = pPos->PosY;
	pPosData->PosZ = pPos->PosZ;
	pPosData->RotX = pPos->RotX;
	pPosData->RotY = pPos->RotY;
	pPosData->RotZ = pPos->RotZ;
	cref->AddSubRec(pos);

	return cref;
}

void printSubRecord(CEsmSubRecord* pSubRecord, int indentation) {
	string indent = "\n";
	for (int i = 0; i < indentation; i++) {
		indent += "\t";
	}
	cout << indent << "sub rec type: " << pSubRecord->GetType();
	if (pSubRecord->IsType(MWESM_SUBREC_CREF)) {
		CEsmSubCellRef* subCell = (CEsmSubCellRef*)pSubRecord;
		int numSubRecords2 = subCell->GetNumSubRecs();
		cout << indent << "\tNum cref sub recs = " << numSubRecords2;
		for (int j = 0; j < numSubRecords2; j++) {
			printSubRecord(subCell->GetSubRec(j), indentation + 1);
		}
	} else if (pSubRecord->IsType(MWESM_SUBREC_NAME)) {
		CEsmSubName* name = (CEsmSubName*)pSubRecord;
		cout << indent << '\t' << name->GetName();
	} else {
		if (pSubRecord->GetData() != NULL) {
			int size = pSubRecord->GetRecordSize();
			byte* data = pSubRecord->GetData();
			for (int i = 0; i < size; i++) {
				if ((i % 8) == 0) { 
					cout << indent << '\t';	
				}
				cout << "0x" << hex << (int)*data << " ";
				data++;
			}
		}
	}
}

void printRecord(CEsmRecord* pRecord) {
	printf ("Record ID = %s\n", pRecord->GetID());
	printf ("Num subrecords = %d\n", pRecord->GetNumSubRecords());
	int numSubrecords = pRecord->GetNumSubRecords();    
	for (int i = 0; i < numSubrecords; i++) {
		printSubRecord(pRecord->GetSubRecord(i), 1);
	}
}
