/*===========================================================================
 *
 * File:	Esmgloboptions.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	September 7, 2003
 *
 * Implements the global functions for accessing and returning the
 * various MWEdit options.
 *
 *=========================================================================*/

	/* Include Files */
#include "Stdafx.h"
#include "esmgloboptions.h"
#include "EsmOptions.h"
#include "MwEdit.h"


/*===========================================================================
 *
 * Begin Local Definitions
 *
 *=========================================================================*/
  DEFINE_FILE("EsmGlobOptions.cpp");
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Function - bool GetEsmOptNoScriptFormat (void);
 *
 * Returns the current no-script-format options flag.
 *
 *=========================================================================*/
bool GetEsmOptNoScriptFormat (void) {
  CMWEditApp* pApp = (CMWEditApp *) AfxGetApp();
  return (pApp->GetOptions()->GetNoScriptFormat());
 }
/*===========================================================================
 *		End of Function GetEsmOptNoScriptFormat()
 *=========================================================================*/


/*===========================================================================
 *
 * Function - int GetEsmOptScriptWarnLevel (void);
 *
 * Returns the current script compiler message level setting.
 *
 *=========================================================================*/
int GetEsmOptScriptWarnLevel (void) {
  CMWEditApp* pApp = (CMWEditApp *) AfxGetApp();
  return (pApp->GetOptions()->GetScriptWarnLevel());
 }
/*===========================================================================
 *		End of Function GetEsmOptScriptWarnLevel()
 *=========================================================================*/


/*===========================================================================
 *
 * Function - int GetEsmOptScriptFormatType (void);
 *
 * Return the current type of the script format.
 *
 *=========================================================================*/
int GetEsmOptScriptFormatType (void) {
  CMWEditApp* pApp = (CMWEditApp *) AfxGetApp();
  return (pApp->GetOptions()->GetFormatType());
 }
/*===========================================================================
 *		End of Function GetEsmOptScriptFormatType()
 *=========================================================================*/


/*===========================================================================
 *
 * Function - CEsmScriptOptions* GetEsmOptScriptOptions (void);
 *
 * Gets the current script options object.
 *
 *=========================================================================*/
CEsmScriptOptions* GetEsmOptScriptOptions (void) {
  CMWEditApp* pApp = (CMWEditApp *) AfxGetApp();
  return (pApp->GetOptions()->GetScriptOptions());
 }
/*===========================================================================
 *		End of Function GetEsmOptScriptOptions()
 *=========================================================================*/


/*===========================================================================
 *
 * Function - const TCHAR* GetEsmOptDefaultAuthor (void);
 *
 * Returns the default author string from the application options.
 *
 *=========================================================================*/
const TCHAR* GetEsmOptDefaultAuthor (void) {
  CMWEditApp* pApp = (CMWEditApp *) AfxGetApp();
  return (pApp->GetOptions()->GetAuthorName());
 }
/*===========================================================================
 *		End of Function TCHAR* GetEsmOptDefaultAuthor()
 *=========================================================================*/

