/*===========================================================================
 *
 * File:	Esmscriptfuncs.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Wednesday, February 12, 2003
 *
 * Description
 *
 *=========================================================================*/

	/* Include Files */
#include "esmscriptdefs.h"
#include "GenFile.h"

	/* Shorter definitions for convienence */
  #define VN   0
  #define VB   ESMSCR_FUNC_BYTE
  #define VS   ESMSCR_FUNC_SHORT
  #define VL   ESMSCR_FUNC_LONG
  #define VF   ESMSCR_FUNC_FLOAT
  #define VSTR ESMSCR_FUNC_STRING
  #define VSST ESMSCR_FUNC_SHORTSTR
  #define VEXS ESMSCR_FUNC_EXTRASHORT
  #define VNOO ESMSCR_FUNC_NOOPTOUT
  #define VID  ESMSCR_FUNC_ID
  #define VEFF ESMSCR_FUNC_EFFECT
  #define VX   ESMSCR_FUNC_XYZ
  #define VOPT ESMSCR_FUNC_OPTIONAL
  #define VNR  ESMSCR_FUNC_NOTREQ
  #define VTRB ESMSCR_FUNC_TRIBUNAL
  #define VBM  ESMSCR_FUNC_BLOODMOON
  #define VSV  ESMSCR_FUNC_SHORTVAR
  #define VDLG ESMSCR_FUNC_DIALOGUE
  #define VAG  ESMSCR_FUNC_ALLOWGLOBAL
  #define VBAD ESMSCR_FUNC_BAD
  #define VVAR ESMSCR_FUNC_VAR
  #define VRST ESMSCR_FUNC_RESET
  #define VCSTR ESMSCR_FUNC_CELLSTR
  #define VCID  ESMSCR_FUNC_CELLID
  #define VEID  ESMSCR_FUNC_EFFECTID
  #define VLCID ESMSCR_FUNC_LEVELCID
  #define VLIID ESMSCR_FUNC_LEVELIID
  #define VSGID ESMSCR_FUNC_SOULGEMID
  #define VCRID ESMSCR_FUNC_CREATUREID
  #define VNPID ESMSCR_FUNC_NPCID
  #define VSPID ESMSCR_FUNC_SPELLID
  #define VTPID ESMSCR_FUNC_TOPICID
  #define VREG  ESMSCR_FUNC_REGIONID
  #define VITMID ESMSCR_FUNC_ITEMID
  #define VFAC   ESMSCR_FUNC_FACTIONID
  #define VJRNID ESMSCR_FUNC_JOURNALID
  #define VRAID  ESMSCR_FUNC_RACEID
  #define VSNDID ESMSCR_FUNC_SOUNDID
  #define VSCTID ESMSCR_FUNC_SCRIPTID
  #define VANIM  ESMSCR_FUNC_ANIM
  #define VMNY   ESMSCR_FUNC_MANY

  #define VOST  ESMSCR_FUNC_OPTSTART

esmscrfuncinfo_t g_ScriptFunctions[] = {
/*0*/ 	{ _T("Activate"),		VNOO,	VN, VID|VOPT, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1017 },	
	{ _T("AddItem"),		0,	VN, VID, VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10D4 },
	{ _T("AddSoulGem"),		0,	VN, VID|VSGID, VID | VCRID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10EB },
	{ _T("AddSpell"),		0,	VN, VID|VSPID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x111D },
	{ _T("AddToLevCreature"),	VTRB,	VN, VID|VLCID, VID|VCRID|VNPID, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x11a6 },
	{ _T("AddToLevItem"),		VTRB,	VN, VID|VLIID, VID, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x11a8 },
	{ _T("AddTopic"),		0,	VN, VID|VTPID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1022 },
	{ _T("AIActivate"),		0,	VN, VID, VRST|VOPT, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10F3 },
	{ _T("AIEscort"),		0,	VN, VID|VNPID|VCRID, VS, VF, VF, VF, VRST|VOPT, VN, VN, VN, VN, VN, VN,	0x10F4 },
	{ _T("AIEscortCell"),		0,	VN, VID|VNPID|VCRID, VID|VCID, VS, VF, VF, VF, VRST|VOPT, VN, VN, VN, VN, VN,	0x10F5 },
	{ _T("AIFollow"),		0,	VN, VID|VNPID|VCRID, VS, VF, VF, VF, VRST|VOPT, VN, VN, VN, VN, VN, VN,	0x10F6 },
	{ _T("AIFollowCell"),		0,	VN, VID|VNPID|VCRID, VID|VCID, VS, VF, VF, VF, VRST|VOPT, VN, VN, VN, VN, VN,	0x10F7 },
	{ _T("AITravel"),		0,	VN, VF, VF, VF, VRST|VOPT, VN, VN, VN, VN, VN, VN, VN, VN,	0x10F8 },
	{ _T("AIWander"),		0,	VN, VF, VF, VF|VOST, VS|VOPT, VS|VOPT, VS|VOPT, VS|VOPT, VS|VOPT, VS|VOPT, VS|VOPT, VS|VOPT, VRST|VOPT,	0x10F9 },
/*14*/	{ _T("BecomeWerewolf"),		VBM,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x11B3 },
/*15*/	{ _T("Cast"),			0,	VN, VID|VSPID, VID|VNPID|VCRID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1123 },
	{ _T("CellChanged"),		0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x101F },
	{ _T("CellUpdate"),		VBAD,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1013 },
	{ _T("ChangeWeather"),		0,	VN, VID|VREG, VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1124 },
	{ _T("Choice"),			VDLG,	VN, VSTR, VSTR|VNR, VSTR|VNR, VSTR|VNR, VSTR|VNR, VSTR|VNR, VSTR|VNR, VSTR|VNR, VSTR|VNR, VSTR|VNR, VSTR|VNR, VSTR|VNR,	0x10C9 },
	{ _T("ClearForceJump"),		VTRB,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x119e },
	{ _T("ClearForceMoveJump"),	VTRB,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x11a1 },
	{ _T("ClearForceRun"),		VTRB,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x119b },
	{ _T("ClearForceSneak"),	0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1164 },
	{ _T("ClearInfoActor"),		0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10CB },
/*25*/	{ _T("Disable"),		0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10DB },
	{ _T("DisableLevitation"),	VTRB,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1194 },
	{ _T("DisablePlayerControls"),	0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10DE },
	{ _T("DisablePlayerFighting"),	0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x115A },
	{ _T("DisablePlayerJumping"),	0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1140 },
	{ _T("DisablePlayerLooking"),	0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1143 },
	{ _T("DisablePlayerMagic"),	0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x115D },
	{ _T("DisablePlayerViewSwitch"),0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10E3 },
	{ _T("DisableTeleporting"),	0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10Ef },
	{ _T("DisableVanityMode"),	0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x114c },
	{ _T("DontSaveObject"),		VTRB,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x115f },
	{ _T("Drop"),			0,	VN, VID, VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x110d },
	{ _T("DropSoulGem"),		0,	VN, VID|VCRID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10ed },
/*38*/	{ _T("Enable"),			0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10da },
	{ _T("EnableBirthMenu"),	0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1129 },
	{ _T("EnableClassMenu"),	0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1128 },
	{ _T("EnableInventoryMenu"),	0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1118 },
	{ _T("EnableLevelupMenu"),	0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1158 },
	{ _T("EnableLevitation"),	VTRB,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1193 },
	{ _T("EnableMagicMenu"),	0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x111a },
	{ _T("EnableMapMenu"),		0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1119 },
	{ _T("EnableNameMenu"),		0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1126 },
	{ _T("EnablePlayerControls"),	0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10dd },
	{ _T("EnablePlayerFighting"),	0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1159 },
	{ _T("EnablePlayerJumping"),	0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x113f },
	{ _T("EnablePlayerLooking"),	0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1142 },
	{ _T("EnablePlayerMagic"),	0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x115c },
	{ _T("EnablePlayerViewSwitch"),	0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10e2 },
	{ _T("EnableRaceMenu"),		0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1127 },
	{ _T("EnableRest"),		0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x013f },
	{ _T("EnableStatReviewMenu"),	0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1160 },
	{ _T("EnableStatsMenu"),	0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1117 },
	{ _T("EnableTeleporting"),	0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10ee },
	{ _T("EnableVanityMode"),	0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x114b },
	{ _T("Equip"),			0,	VN, VID|VITMID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x110e },
	{ _T("ExplodeSpell"),		VTRB,	VN, VID|VSPID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x11ad },
/*61*/	{ _T("Face"),			0,	VN, VF, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1162 },
	{ _T("FadeIn"),			0,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1131 },
	{ _T("FadeOut"),		0,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1130 },
	{ _T("FadeTo"),			0,	VN, VL, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1145 },
	{ _T("Fall"),			0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1166 },
	{ _T("ForceGreeting"),		0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10e8 },
	{ _T("ForceJump"),		VTRB,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x119d },
	{ _T("ForceMoveJump"),		VTRB,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x11a0 },
	{ _T("ForceRun"),		VTRB,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x119a },
	{ _T("ForceSneak"),		0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1163 },
/*71*/	{ _T("GetAcrobatics"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1077 },
	{ _T("GetAgility"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x102c },
	{ _T("GetAIPackageDone"),	0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10fb },
	{ _T("GetAlarm"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1105 },
	{ _T("GetAlchemy"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x106b },
	{ _T("GetAlteration"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x105c },
	{ _T("GetAngle"),		0,	VF, VX, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x100c },
	{ _T("GetArmorBonus"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1176 },
	{ _T("GetArmorer"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x103e },
	{ _T("GetArmorType"),		VTRB,	VF, VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1198 },
	{ _T("GetAthletics"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1053 },
	{ _T("GetAttackBonus"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10a2 },
	{ _T("GetAttacked"),		0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1148 },
	{ _T("GetAxe"),			0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x104d },
	{ _T("GetBlightDisease"),	0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x114a },
	{ _T("GetBlindness"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x117f },
	{ _T("GetBlock"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x103b },
	{ _T("GetBluntWeapon"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1047 },
	{ _T("GetButtonPressed"),	0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x101e },
	{ _T("GetCastPenalty"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1179 },
	{ _T("GetChameleon"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10c3 },
	{ _T("GetCollidingActor"),	VTRB,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x11a4 },
	{ _T("GetCollidingPC"),		VTRB,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x11a3 },
	{ _T("GetCommonDisease"),	0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1149 },
	{ _T("GetConjuration"),		0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1062 },
	{ _T("GetCurrentAIPackage"),	0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10fa },
	{ _T("GetCurrentTime"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1011 },
	{ _T("GetCurrentWeather"),	0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10a1 },
	{ _T("GetDeadCount"),		0,	VL, VID|VNPID|VCRID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10fe },
	{ _T("GetDefendBonus"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10a5 },
	{ _T("GetDestruction"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1059 },
	{ _T("GetDetected"),		0,	VS, VID|VNPID|VCRID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x114e },
	{ _T("GetDisabled"),		0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10dc },
	{ _T("GetDisposition"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1098 },
	{ _T("GetDistance"),		0,	VF, VID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1001 },
	{ _T("GetEffect"),		VSV,	VS, VEFF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1138 },
	{ _T("GetEnchant"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1056 },
	{ _T("GetEndurance"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1032 },
	{ _T("GetFactionReaction"),	0,	VF, VID|VFAC, VID|VFAC, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1153 },
	{ _T("GetFatigue"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1092 },
	{ _T("GetFight"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10ff },
	{ _T("GetFlee"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1102 },
	{ _T("GetFlying"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1173 },
	{ _T("GetForceJump"),		VTRB,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x119f },
	{ _T("GetForceMoveJump"),	VTRB,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x11a2 },
	{ _T("GetForceRun"),		VTRB,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x119c },
	{ _T("GetForceSneak"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1165 },
	{ _T("GetHandToHand"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1089 },
	{ _T("GetHealth"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x108c },
	{ _T("GetHealthGetRatio"),	0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1154 },
	{ _T("GetHeavyArmor"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1044 },
	{ _T("GetHello"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1108 },
	{ _T("GetIllusion"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x105f },
	{ _T("GetIntelligence"),	0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1026 },
	{ _T("GetInterior"),		0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x110b },
	{ _T("GetInvisible"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1185 },
	{ _T("GetItemCount"),		0,	VL, VID|VITMID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10fd },
	{ _T("GetJournalIndex"),	0,	VL, VID|VJRNID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10cd },
	{ _T("GetLevel"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1157 },
	{ _T("GetLightArmor"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x107a },
	{ _T("GetLineOfSight"),		0,	VS, VID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10fc },
	{ _T("GetLocked"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1161 },
	{ _T("GetLongBlade"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x104a },
	{ _T("GetLuck"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1038 },
	{ _T("GetMagicka"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x108f },
	{ _T("GetMarksman"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1080 },
	{ _T("GetMasserPhase"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1146 },
	{ _T("GetMediumArmor"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1041 },
	{ _T("GetMercantile"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1083 },
	{ _T("GetMysticism"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1065 },
	{ _T("GetParalysis"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1182 },
	{ _T("GetPCCell"),		0,	VS, VID|VCID|VCSTR, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1112 },
	{ _T("GetPCCrimeLevel"),	0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x109b },
	{ _T("GetPCFacRep"),		0,	VF, VID|VFAC, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10d7 },
	{ _T("GetPCinJail"),		VBM,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x11BB },
	{ _T("GetPCJumping"),		VTRB,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x118c },
	{ _T("GetPCRank"),		0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x110c },
	{ _T("GetPCRunning"),		VTRB,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x118b },
	{ _T("GetPCSleep"),		0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10e0 },
	{ _T("GetPCSneaking"),		VTRB,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x118a },
	{ _T("GetPCTraveling"),		VBM,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x11BC },
	{ _T("GetPCVisionBonus"),	0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x11b0 },
	{ _T("GetPersonality"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1035 },
	{ _T("GetPlayerControlsDisabled"),	0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10df },
	{ _T("GetPlayerFightingDisabled"),	0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x115b },
	{ _T("GetPlayerJumpingDisabled"),	0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1141},
	{ _T("GetPlayerLookingDisabled"),	0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1144 },
	{ _T("GetPlayerMagicDisabled"),		0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x115e },
	{ _T("GetPlayerViewSwitch"),		VBAD,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10e4 },
	{ _T("GetPos"),			0,	VF, VX, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x100a },
	{ _T("GetRace"),		0,	VS, VID|VRAID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1139 },
	{ _T("GetReputation"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1095 },
	{ _T("GetResistBlight"),	0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10b7 },
	{ _T("GetResistCorprus"),	0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10ba },
	{ _T("GetResistDisease"),	0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10b4 },
	{ _T("GetResistFire"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10ab },
	{ _T("GetResistFrost"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10ae },
	{ _T("GetResistMagicka"),	0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10a8 },
	{ _T("GetResistNormalWeapons"),	0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10c6 },
	{ _T("GetResistParalysis"),	0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10c0 },
	{ _T("GetResistPoison"),	0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10bd },
	{ _T("GetResistShock"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10b1 },
	{ _T("GetRestoration"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1068 },
	{ _T("GetScale"),		VTRB,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x118d },
	{ _T("GetSecondsPassed"),	0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1012 },
	{ _T("GetSecundaPhase"),	0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1147 },
	{ _T("GetSecurity"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1071 },
	{ _T("GetShortBlade"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x107d },
	{ _T("GetSilence"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x117c },
	{ _T("GetSneak"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1074 },
	{ _T("GetSoundPlaying"),	0,	VS, VID|VSNDID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1188 },
	{ _T("GetSpear"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1050 },
	{ _T("GetSpeechcraft"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1086 },
	{ _T("GetSpeed"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x102f },
	{ _T("GetSpell"),		0,	VS, VID|VSPID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x111f },
	{ _T("GetSpellEffects"),	0,	VS, VID|VSPID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1121 },
	{ _T("GetSpellReadied"),	VTRB,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x11af },
	{ _T("GetSquareRoot"),		VVAR|VTRB|VAG,	VF, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x11ac },
	{ _T("GetStandingActor"),	0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1114 },
	{ _T("GetStandingPC"),		0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1113 },
	{ _T("GetStartingAngle"),	0,	VF, VX, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x100f },
	{ _T("GetStartingPos"),		0,	VF, VX, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x100e },
	{ _T("GetStrength"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1023 },
	{ _T("GetSuperJump"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1170 },
	{ _T("GetSwimSpeed"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x116d },
	{ _T("GetTarget"),		0,	VF, VID/*|VCRID|VNPID*/, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1150 },
	{ _T("GetUnarmored"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x106e },
	{ _T("GetVanityModeDisabled"),	0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x114d },
	{ _T("GetWaterBreathing"),	0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1167 },
	{ _T("GetWaterLevel"),		VTRB,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1190 },
	{ _T("GetWaterWalking"),	0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x116a },
	{ _T("GetWeaponDrawn"),		VTRB,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x11ae },
	{ _T("GetWeaponType"),		VTRB,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1197 },
	{ _T("GetWerewolfKills"),	VBM,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x11B6 },
	{ _T("GetWillpower"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1029 },
	{ _T("GetWindSpeed"),		0,	VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10a0 },
	{ _T("Goodbye"),		0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10ca },
	{ _T("GoToJail"),		0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10e9 },
/*209*/	{ _T("HasItemEquipped"),	VTRB,	VS, VID|VITMID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1199 },
	{ _T("HasSoulGem"),		0,	VS, VID|VCRID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10ea },
	{ _T("HitAttemptOnMe"),		0,	VS, VID|VITMID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1116 },
	{ _T("HitOnMe"),		0,	VS, VID|VITMID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1115 },
	{ _T("HurtCollidingActor"),	0,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x11a5 },
	{ _T("HurtStandingActor"),	0,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1135 },
/*215*/	{ _T("IsWerewolf"),		VBM,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x11B5 },
/*216*/	{ _T("Journal"),		VEXS,	VN, VID|VJRNID, VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10cc },
/*217*/	{ _T("Lock"),			0,	VN, VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1136 },
	{ _T("LoopGroup"),		0,	VN, VANIM, VB, VB|VOPT, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1015 },
	{ _T("LowerRank"),		0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10cf },
/*220*/	{ _T("MenuMode"),		0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1020 },
	{ _T("MessageBox"),	 	VAG|VSV|VVAR,	VN, VSTR, VF|VOPT|VNR|VMNY, VSTR|VOPT|VMNY, VN, VN, VN, VN, VN, VN, VN, VN, VN, 0x1000 },
	{ _T("ModAcrobatics"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1079 },
	{ _T("ModAgility"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x102e },
	{ _T("ModAlarm"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1107 },
	{ _T("ModAlchemy"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x106d },
	{ _T("ModAlteration"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x105e },
	{ _T("ModArmorBonus"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1178 },
	{ _T("ModArmorer"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1040 },
	{ _T("ModAthletics"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1055 },
	{ _T("ModAttackBonus"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10a4 },
	{ _T("ModAxe"),			VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x104f },
	{ _T("ModBlindness"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1181 },
	{ _T("ModBlock"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x103d },
	{ _T("ModBluntWeapon"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1049 },
	{ _T("ModCastPenalty"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x117b },
	{ _T("ModChameleon"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10c5 },
	{ _T("ModConjuration"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1064 },
	{ _T("ModCurrentFatigue"),	VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1134 },
	{ _T("ModCurrentHealth"),	VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1132 },
	{ _T("ModCurrentMagicka"),	VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1133 },
	{ _T("ModDefendBonus"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10a7 },
	{ _T("ModDestruction"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x105b },
	{ _T("ModDisposition"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x109a },
	{ _T("ModEnchant"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1058 },
	{ _T("ModEndurance"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1034 },
	{ _T("ModFactionReaction"),	0,	VN, VID|VFAC, VID|VFAC, VS, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1111 },
	{ _T("ModFatigue"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1094 },
	{ _T("ModFight"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1101 },
	{ _T("ModFlee"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1104 },
	{ _T("ModFlying"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1175 },
	{ _T("ModHandToHand"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x108b },
	{ _T("ModHealth"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x108e },
	{ _T("ModHeavyArmor"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1046 },
	{ _T("ModHello"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x110a },
	{ _T("ModIllusion"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1061 },
	{ _T("ModIntelligence"),	VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1028 },
	{ _T("ModInvisible"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1187 },
	{ _T("ModLightArmor"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x107c },
	{ _T("ModLongBlade"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x104c },
	{ _T("ModLuck"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x103a },
	{ _T("ModMagicka"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1091 },
	{ _T("ModMarksman"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1082 },
	{ _T("ModMediumArmor"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1043 },
	{ _T("ModMercantile"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1085 },
	{ _T("ModMysticism"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1067 },
	{ _T("ModParalysis"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1184 },
	{ _T("ModPCCrimeLevel"),	VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x109d },
	{ _T("ModPCFacRep"),		0,	VN, VF, VID|VFAC|VOPT, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10d9 },
	{ _T("ModPCVisionBonus"),	VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x11b2 },
	{ _T("ModPersonality"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1037 },
	{ _T("ModRegion"),		0,	VN, VID|VREG, VB, VB, VB, VB, VB, VB, VB, VB, VB, VB, VN,	0x1125 },
	{ _T("ModReputation"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1097 },
	{ _T("ModResistBlight"),	VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10b9 },
	{ _T("ModResistCorprus"),	VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10bc },
	{ _T("ModResistDisease"),	VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10b6 },
	{ _T("ModResistFire"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10ad },
	{ _T("ModResistFrost"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10b0 },
	{ _T("ModResistMagicka"),	VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10aa },
	{ _T("ModResistNormalWeapons"),	VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10c8 },
	{ _T("ModResistParalysis"),	VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10c2 },
	{ _T("ModResistPoison"),	VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10bf },
	{ _T("ModResistShock"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10b3 },
	{ _T("ModRestoration"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x106a },
	{ _T("ModScale"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x118f },
	{ _T("ModSecurity"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1073 },
	{ _T("ModShortBlade"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x107f },
	{ _T("ModSilence"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x117e },
	{ _T("ModSneak"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1076 },
	{ _T("ModSpear"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1052 },
	{ _T("ModSpeechcraft"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1088 },
	{ _T("ModSpeed"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1031 },
	{ _T("ModStrength"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1025 },
	{ _T("ModSuperJump"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1172 },
	{ _T("ModSwimSpeed"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x116f },
	{ _T("ModUnarmored"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1070 },
	{ _T("ModWaterBreathing"),	VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1169 },
	{ _T("ModWaterLevel"),		VTRB|VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1192 },
	{ _T("ModWaterWalking"),	VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x116c },
	{ _T("ModWillpower"),		VSV|VVAR ,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x102b },
	{ _T("Move"),			0,	VN, VX, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1006 },
	{ _T("MoveWorld"),		0,	VN, VX, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1008 },
/*302*/	{ _T("OnActivate"),		0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1018 },
	{ _T("OnDeath"),		0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10f0 },
	{ _T("OnKnockout"),		0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10f1 },
	{ _T("OnMurder"),		0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10f2 },
/*306*/	{ _T("PayFine"),		0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x114f },
	{ _T("PayFineThief"),		0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1189 },
	{ _T("PCClearExpelled"),	0,	VN, VID|VOPT, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10d3 },
	{ _T("PCExpell"),		0,	VN, VID|VOPT, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10d2 },
	{ _T("PCExpelled"),		0,	VN, VID|VOPT, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x109f },
	{ _T("PCForce1stPerson"),	0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x113d },
	{ _T("PCForce3rdPerson"),	0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x113c },
	{ _T("PCGet3rdPerson"),		0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x113e },
	{ _T("PCJoinFaction"),		0,	VN, VID|VOPT, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x113b },
	{ _T("PCLowerRank"),		0,	VN, VID|VOPT, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10d1 },
	{ _T("PCRaiseRank"),		0,	VN, VID|VOPT, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10d0 },
	{ _T("PlaceAtMe"),		VSV|VBM,VN, VID, VS, VF, VS, VN, VN, VN, VN, VN, VN, VN, VN,		0x11BA },
	{ _T("PlaceAtPC"),		VSV,	VN, VID, VS, VF, VS, VN, VN, VN, VN, VN, VN, VN, VN,		0x10e6 },
	{ _T("PlaceItem"),		VTRB|VSV|VVAR,	VN, VID, VF, VF, VF, VF, VN, VN, VN, VN, VN, VN, VN,		0x1195 },
	{ _T("PlaceItemCell"),		VTRB|VSV|VVAR,	VN, VID, VID|VCID, VF, VF, VF, VF, VN, VN, VN, VN, VN, VN,	0x1196 },
	{ _T("PlayBink"),		VSV,	VN, VSTR, VB|VOPT, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1155 },
	{ _T("PlayGroup"),		VSV,	VN, VANIM, VB|VOPT, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1014 },
	{ _T("PlayLoopSound3D"),	VSV,	VN, VID|VSNDID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x112e },
	{ _T("PlayLoopSound3DVP"),	VSV,	VN, VID|VSNDID, VF, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x112f },
	{ _T("PlaySound"),		VSV,	VN, VID|VSNDID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1002 },
	{ _T("PlaySound3D"),		VSV,	VN, VID|VSNDID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x112c },
	{ _T("PlaySound3DVP"),		VSV,	VN, VID|VSNDID, VF, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x112d },
	{ _T("PlaySoundVP"),		VSV,	VN, VID|VSNDID, VF, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x112b },
	{ _T("Position"),		0,	VN, VF, VF, VF, VF, VN, VN, VN, VN, VN, VN, VN, VN,		0x1004 },
	{ _T("PositionCell"),		0,	VN, VF, VF, VF, VF, VID|VCID, VN, VN, VN, VN, VN, VN, VN,	0x1005 },
/*331*/	{ _T("RaiseRank"),		0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10ce },
	{ _T("Random"),			0,	VS, VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1021 },
	{ _T("RemoveEffects"),		0,	VN, VEFF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1122 },
	{ _T("RemoveFromLevCreature"),	VTRB,	VN, VID|VLCID, VID|VCRID|VNPID, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x11a7 },
	{ _T("RemoveFromLevItem"),	VTRB,	VN, VID|VLIID, VID|VITMID, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x11a9 },
	{ _T("RemoveItem"),		0,	VN, VID|VITMID, VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10d5 },
	{ _T("RemoveSoulGem"),		0,	VN, VID|VCRID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10ec },
	{ _T("RemoveSpell"),		0,	VN, VID|VSPID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x111e },
	{ _T("RemoveSpellEffects"),	0,	VN, VID|VSPID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1120 },
	{ _T("RepairedOnMe"),		0,	VN, VID|VITMID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x110f },
	{ _T("Resurrect"),		0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10e7 },
	{ _T("Rotate"),			0,	VN, VX, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1007 },
	{ _T("RotateWorld"),		0,	VN, VX, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1009 },
/*344*/	{ _T("SameFaction"),		0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x109e },
	{ _T("Say"),			0,	VN, VSTR|VSST, VSTR, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x111b },
	{ _T("SayDone"),		0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x111c },
	{ _T("ScriptRunning"),		0,	VS, VID|VSCTID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x101d },
	{ _T("SetAcrobatics"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1078 },
	{ _T("SetAgility"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x102d },
	{ _T("SetAlarm"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1106 },
	{ _T("SetAlchemy"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x106c },
	{ _T("SetAlteration"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x105d },
	{ _T("SetAngle"),		VVAR|VSV,	VN, VX, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x100d },
	{ _T("SetArmorBonus"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1177 },
	{ _T("SetArmorer"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x103f },
	{ _T("SetAthletics"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1054 },
	{ _T("SetAtStart"),		0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1010 },
	{ _T("SetAttackBonus"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10a3 },
	{ _T("SetAxe"),			VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x104e },
	{ _T("SetBlindness"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1180 },
	{ _T("SetBlock"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x103c },
	{ _T("SetBluntWeapon"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1048 },
	{ _T("SetCastPenalty"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x117a },
	{ _T("SetChameleon"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10c4 },
	{ _T("SetConjuration"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1063 },
	{ _T("SetDefendBonus"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10a6 },
	{ _T("SetDelete"),		VTRB,	VN, VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x11ab },
	{ _T("SetDestruction"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x105a },
	{ _T("SetDisposition"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1099 },
	{ _T("SetEnchant"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1057 },
	{ _T("SetEndurance"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1033 },
	{ _T("SetFactionReaction"),	0,	VN, VID|VFAC, VID|VFAC, VS, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1110 },
	{ _T("SetFatigue"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1093 },
	{ _T("SetFight"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1100 },
	{ _T("SetFlee"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1103 },
	{ _T("SetFlying"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1174 },
	{ _T("SetHandToHand"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x108a },
	{ _T("SetHealth"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x108d },
	{ _T("SetHeavyArmor"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1045 },
	{ _T("SetHello"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1109 },
	{ _T("SetIllusion"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1060 },
	{ _T("SetIntelligence"),	VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1027 },
	{ _T("SetInvisible"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1186 },
	{ _T("SetJournalIndex"),	VEXS,	VN, VID|VJRNID, VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x11aa },
	{ _T("SetLevel"),		VVAR|VSV,	VN, VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1156 },
	{ _T("SetLightArmor"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x107b },
	{ _T("SetLongBlade"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x104b },
	{ _T("SetLuck"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1039 },
	{ _T("SetMagicka"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1090 },
	{ _T("SetMarksman"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1081 },
	{ _T("SetMediumArmor"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1042 },
	{ _T("SetMercantile"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1084 },
	{ _T("SetMysticism"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1066 },
	{ _T("SetParalysis"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1183 },
	{ _T("SetPCCrimeLevel"),	0,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x109c },
	{ _T("SetPCFacRep"),		0,	VN, VF, VID|VFAC|VOPT, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10d8 },
	{ _T("SetPCVisionBonus"),	VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x11b1 },
	{ _T("SetPersonality"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1036 },
	{ _T("SetPos"),			VVAR|VSV,	VN, VX, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x100b }, /* Accepts Vars since Tribunal */
	{ _T("SetReputation"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1096 },
	{ _T("SetResistBlight"),	VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10b8 },
	{ _T("SetResistCorprus"),	VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10bb },
	{ _T("SetResistDisease"),	VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10b5 },
	{ _T("SetResistFire"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10ac },
	{ _T("SetResistFrost"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10af },
	{ _T("SetResistMagicka"),	VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10a9 },
	{ _T("SetResistNormalWeapons"),	VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10c7 },
	{ _T("SetResistParalysis"),	VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10c1 },
	{ _T("SetResistPoison"),	VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10be },
	{ _T("SetResistShock"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x10b2 },
	{ _T("SetRestoration"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1069 },
	{ _T("SetScale"),		VVAR|VTRB|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x118e },
	{ _T("SetSecurity"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1072 },
	{ _T("SetShortBlade"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x107e },
	{ _T("SetSilence"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x117d },
	{ _T("SetSneak"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1075 },
	{ _T("SetSpear"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1051 },
	{ _T("SetSpeechcraft"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1087 },
	{ _T("SetSpeed"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1030 },
	{ _T("SetStrength"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1024 },
	{ _T("SetSuperJump"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1171 },
	{ _T("SetSwimSpeed"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x116e },
	{ _T("SetUnarmored"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x106f },
	{ _T("SetWaterBreathing"),	VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1168 },
	{ _T("SetWaterLevel"),		VVAR|VTRB|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1191 },
	{ _T("SetWaterWalking"),	VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x116b },
	{ _T("SetWereWolfAcrobatics"),	VBM,		VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x11B9 },
	{ _T("SetWillpower"),		VVAR|VSV,	VN, VF, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x102a },
	{ _T("Show"),			VBAD|VSV,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x010d },
	{ _T("ShowMap"),		0,	VN, VID|VCID|VCSTR, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1152},
	{ _T("ShowRestMenu"),		0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10e5 },
	{ _T("SkipAnim"),		0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1016 },
	{ _T("StartCombat"),		0,	VN, VID|VNPID|VCRID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,0x1019 },
	{ _T("StartScript"),		0,	VN, VID|VSCTID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x101b },
	{ _T("StopCombat"),		0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x101a },
	{ _T("StopScript"),		0,	VN, VID|VSCTID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x101c },
	{ _T("StopSound"),		0,	VN, VID|VSNDID, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1151 },
	{ _T("StreamMusic"),		0,	VN, VSTR|VSST, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,	0x1003 },
/*439*/	{ _T("TurnMoonRed"),		VBM,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x11B7 },
	{ _T("TurnMoonWhite"),		VBM,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x11B8 },
/*441*/	{ _T("UndoWerewolf"),		VBM,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x11B4 },
	{ _T("Unlock"),			0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x1137 },
/*443*/	{ _T("WakeUpPC"),		0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x10e1 },
/*444*/	{ _T("XBox"),			0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN,		0x113a },
	{ NULL }
 };

 	//{ _T("OnPCAdd"),		0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN },
	//{ _T("OnPCDrop"),		0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN },
	//{ _T("OnPCEquip"),		0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN },
	//{ _T("OnPCSoulGemUse"),		0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN },
	//{ _T("OnRepair"),		0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN },
	//{ _T("OnPCHitMe"),		0,	VS, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN },
	//{ _T("PCSkipEquip"),		0,	VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN, VN },

esmscrfuncinfo_t* g_ScriptFuncAlpha[26] = {
	&g_ScriptFunctions[0],		/* A */
	&g_ScriptFunctions[14],		/* B */
	&g_ScriptFunctions[15],		/* C */
	&g_ScriptFunctions[25],		/* D */
	&g_ScriptFunctions[38],		/* E */
	&g_ScriptFunctions[61],		/* F */
	&g_ScriptFunctions[71],		/* G */
	&g_ScriptFunctions[209],	/* H */
	&g_ScriptFunctions[215],	/* I */
	&g_ScriptFunctions[216],	/* J */
	NULL,				/* K */
	&g_ScriptFunctions[217],	/* L */
	&g_ScriptFunctions[220],	/* M */
	NULL,				/* N */
	&g_ScriptFunctions[302],	/* O */
	&g_ScriptFunctions[306],	/* P */
	NULL,				/* Q */
	&g_ScriptFunctions[331],	/* R */
	&g_ScriptFunctions[344],	/* S */
	&g_ScriptFunctions[439],	/* T */
	&g_ScriptFunctions[441],	/* U */
	NULL,				/* V */
	&g_ScriptFunctions[443],	/* W */
	&g_ScriptFunctions[444],	/* X */
	NULL,				/* Y */
	NULL,				/* Z */
 };


/*===========================================================================
 *
 * Function - bool OutputFunction (File, FuncInfo);
 *
 *=========================================================================*/
bool OutputFunction (CGenFile& File, esmscrfuncinfo_t& FuncInfo) {
  int Index;

  File.Printf(_T("Function = %s\n"), FuncInfo.pName);
  File.Printf(_T("\tOptions = 0x%X\n"), FuncInfo.Flags);
  File.Printf(_T("\tOpcode = 0x%X\n"), FuncInfo.OpCode);
  File.Printf(_T("\tReturn = 0x%X, \"\"\n"), FuncInfo.Return);
  
  for (Index = 0; Index < MWESM_SCRIPT_MAXARGS; Index++) {
    if (FuncInfo.Var[Index] == 0) break;
    File.Printf(_T("\tParam%d = 0x%X, \"\"\n"), Index+1, FuncInfo.Var[Index]);
   }

  File.Printf(_T("\tDesc = \"\"\n"));
  File.Printf(_T("End\n"));
  return (true); 
 }
/*===========================================================================
 *		End of Function OutputFunction()
 *=========================================================================*/


/*===========================================================================
 *
 * Function - bool OutputFunctionDat (pFilename);
 *
 * Outputs a function text data file using the current information in 
 * the function array to the given file. Returns false on any error.
 *
 *=========================================================================*/
bool OutputFunctionDat (const TCHAR* pFilename) {
  CGenFile File;
  bool	   Result;
  int      Index;

	/* Attempt to open the file for output */
  Result = File.Open(pFilename, _T("wt"));
  if (!Result) return (false);

	/* Output all functions in array */
  for (Index = 0; g_ScriptFunctions[Index].pName != NULL; Index++) {
    Result = OutputFunction(File, g_ScriptFunctions[Index]);
    if (!Result) return (false);
   }

  return (true);
 }
/*===========================================================================
 *		End of Function OutputFunctionDat()
 *=========================================================================*/
